#lang racket

;; ---------------------------------------------------------------------
;; a simple counter with memory
;; ---------------------------------------------------------------------

(define counter
  (let ((n 0))                ; create a variable ...
    (lambda ()                ; ... and return a procedure
      (set! n (add1 n))
      n)))

;; ---------------------------------------------------------------------
;; a counter factory
;; ---------------------------------------------------------------------

(define make-counter
  (lambda ()                  ; a procedure ...
    (let ((n 0))              ; ... that creates a variable ...
      (lambda ()              ; ... and then returns a procedure
        (set! n (add1 n))
        n))))

;; ---------------------------------------------------------------------
;; a bounded counter factory
;; ---------------------------------------------------------------------

(define counter-to
  (lambda (limit)             ; a procedure that takes a limit ...
    (let ((n 0))              ; ... and creates a new variable ...
      (lambda ()              ; ... and then returns a procedure
        (if (= (add1 n) limit)
            (set! n 0)
            (set! n (add1 n)))
        n))))

;; ---------------------------------------------------------------------
